package com.connormahaffey.TerraCraft;

import java.util.ArrayList;

/**
 *
 * @author Connor
 */
public class Chunk {
    
    private ArrayList<Block> blocks;
    private int chunkNum;
    private double[] data;

    public Chunk(int chunkNum){
        this.chunkNum = chunkNum;
        blocks = new ArrayList<Block>();
        data = new double[10];
        for(int i = 0; i < data.length; i++){
            data[i] = 0;
        }
    }

    public void addBlock(Block block){
        blocks.add(block);
    }

    public Block getBlock(Location location){
        int tempX, tempY;
        tempX = location.getXInt();
        tempY = location.getYInt();
        tempX = Math.abs((World.CHUNK_WIDTH_PIXELS * chunkNum - tempX) / World.BLOCK_SIZE);
        tempY = Math.abs(tempY / World.BLOCK_SIZE + 1);
        if(tempX * World.CHUNK_HEIGHT + tempY >= 960){
            //get rid of this once we find that pesky null pointer
            System.out.println(chunkNum);//-7
            System.out.println(location.getX() + ":");//-427.84999999999999
            System.out.println(location.getY() + ":");//-1204.3
            System.out.println(location.getXInt() + ":");//-428
            System.out.println(location.getYInt() + ":");//-1205
            System.out.println(tempX + ":");//34
            System.out.println(tempY + ":");//59
            System.out.println(tempX * World.CHUNK_HEIGHT + tempY);//4139
        }
        return blocks.get(tempX * World.CHUNK_HEIGHT + tempY);
    }

    public ArrayList<Block> getBlocks(){
        return blocks;
    }

    public void replace(Block block1, Block block2){
        int index = blocks.indexOf(block1);
        blocks.set(index, block2);
    }

    public void removeBlock(Block block){
        blocks.remove(block);
    }

    public void dispose(){
        blocks.clear();
    }

    public boolean isWithinRange(int spot){
        if(spot >= World.CHUNK_WIDTH_PIXELS * chunkNum && spot < World.CHUNK_WIDTH_PIXELS * chunkNum + World.CHUNK_WIDTH_PIXELS){
            return true;
        }
        else{
            return false;
        }
    }

    public int getChunkNumber(){
        return chunkNum;
    }

    public double[] getData(){
        return data;
    }

    public String getDataToString(){
        String s = "";
        for(int i = 0; i < data.length; i++){
            s += data[i] + ",";
        }

        return s.substring(0, s.length() - 1);
    }

    public void setData(int spot, double value){
        data[spot] = value;
    }

    public void setDataFull(double[] data){
        this.data = data;
    }
}
