package com.connormahaffey.TerraCraft;

/**
 *
 * @author Connor
 */
public abstract class Entity {
    public static final int RIGHT = 1, LEFT = -1, UP = -1, DOWN = 1;
    public double X_SPEED = .15, Y_SPEED = .22, ACCELERATION = .02;
    public boolean active, gravity;
    public double change;
    public Location location;
    public World world;

    public Entity(World world, Location location){
        this.world = world;
        this.location = location;
        active = true;
        gravity = true;
    }

    public abstract void act();

    public void setChange(double change){
        this.change = change;
    }

    public void move(int x, int y){
        //move code - only falls if assumed gravity
    }

    public boolean canMoveX(int direction){
        //test left or right
        return true;
    }

    public boolean canMoveY(int direction){
        //test up or down
        return true;
    }

    public void jump(){
        //assumes gravity
    }

    public double getXSpeed(){
        return X_SPEED;
    }

    public double getYSpeed(){
        return Y_SPEED;
    }

    public double getAcceleration(){
        return ACCELERATION;
    }
    
    public void setXSpeed(double xSpeed){
        X_SPEED = xSpeed;
    }

    public void setYSpeed(double ySpeed){
        Y_SPEED = ySpeed;
    }

    public void setAcceleration(double acceleration){
        ACCELERATION = acceleration;
    }

    public void setActive(boolean active){
        this.active = active;
    }

    public boolean isActive(){
        return active;
    }

    public Location getLocation(){
        return location;
    }

    public void setLocation(Location location){
        this.location = location;
    }

    public boolean isGravity(){
        return gravity;
    }

    public void setGravity(boolean gravity){
        this.gravity = gravity;
    }
}
