package com.connormahaffey.TerraCraft;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.net.URL;
import javax.imageio.ImageIO;

/**
 *
 * @author Connor
 */
public class FileHandler {

    public static String separator = File.separator;
    private String prefix;

    public FileHandler(){

    }

    public FileHandler(String prefix){
        this.prefix = prefix;
    }

    public BufferedImage getInternalImage(String filename){
        BufferedImage image = null;
        try{
            ClassLoader loader = getClass().getClassLoader();
            URL url = loader.getResource("com/connormahaffey/TerraCraftResource/" + filename);
            image = ImageIO.read(url);
        }catch(Exception e){
            e.printStackTrace();
        }

        return image;   
    }

    public Image getBlockImage(BufferedImage image, int x, int y){
        return image.getSubimage(x, y, 40, 40).getScaledInstance(20, 20, 0);//fix for random lines (ok?) - 20, 20, 0
    }

    public Image getFullBlockImage(BufferedImage image, int x, int y){
        return image.getSubimage(x, y, 40, 40);//Return the full block image
    }

    public boolean exists(String location){
        File file = new File(prefix + location);
        return file.exists();
    }

    public String[] read(String location){
        File file = new File(prefix + location);
        try{
            String s = "", full = "";
            BufferedReader in = new BufferedReader(new FileReader(file));
            do{
                full += s + "\n";
                s = in.readLine();
            }while(s != null);
            in.close();
            full = full.substring(1);
            String[] data = full.split("\n");
            return data;
        }catch(Exception e){
            e.printStackTrace();
            return null;
        }
    }
    
    public void write(String[] data, String location){
        File file = new File(prefix + location);
        File path = new File(file.getPath().substring(0, file.getPath().lastIndexOf(File.separator)));
        path.mkdirs();
        try{
            BufferedWriter out = new BufferedWriter(new FileWriter(file));
            for(int i = 0; i < data.length; i++){
                out.write(data[i]);
                out.newLine();
            }
            out.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    public boolean getBool(String[] data, String value){
        for(String temp : data){
            if(temp.toLowerCase().startsWith(value.toLowerCase())){
                temp = temp.replace(value + ":", "");
                if(temp.equals("true")){
                    return true;
                }
                else{
                    return false;
                }
            }
        }

        return false;
    }

    public String getValue(String[] data, String value){
        for(String temp : data){
            if(temp.toLowerCase().startsWith(value.toLowerCase())){
                temp = temp.replace(value + ":", "");
                return temp;
            }
        }
        return "";
    }

    public double[] getList(String s){
        s = s.replace(" ", "");
        String[] data = s.split(",");
        double[] i = new double[data.length];
        for(int j = 0; j < data.length; j++){
            try{
                i[j] = Double.parseDouble(data[j]);
            }catch(Exception e){
                i[j] = 0;
            }
        }

        return i;
    }
}
