package com.connormahaffey.TerraCraft;

import java.awt.Graphics2D;
import java.awt.Image;

public class GameOverlayScreen {

    private FileHandler fileh = new FileHandler();
    private Image outline,selection, 
            stone, dirt, grass, water, sand,
            bedrock, cloud, ph1, ph2, ph3;
    private World world;
    private Block block;
    private int x=45, y=TerraCraft.SIZE_Y - 100;

    private int placer;

    public GameOverlayScreen(World world){
        this.world = world;
    }

    public void init(){
        selection = fileh.getInternalImage("Selection-small.png");
        outline = fileh.getInternalImage("OutLine.png");
        
        stone = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 0, 0);
        dirt  = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 40, 0);
        grass = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 80, 0);
        water = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 120, 0);
        sand  = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 160, 0);
        
        bedrock = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 0, 40);
        cloud = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 40, 40);
        ph1 = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 80, 40);
        ph2 = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 120, 40);
        ph3 = fileh.getBlockImage(fileh.getInternalImage("blocks.png"), 160, 40);
    }

    public void draw(Graphics2D g){
        if(TerraCraft.keyHandler.getBPY() == 0){
            g.drawImage(stone, x+25*0, y, null);
            g.drawImage(dirt, x+25*1, y, null);
            g.drawImage(grass, x+25*2, y, null);
            g.drawImage(water, x+25*3, y, null);
            g.drawImage(sand, x+25*4, y, null);
        } else if(TerraCraft.keyHandler.getBPY() == 1){
            g.drawImage(bedrock, x+25*0, y, null);
            g.drawImage(cloud, x+25*1, y, null);
            g.drawImage(ph1, x+25*2, y, null);
            g.drawImage(ph2, x+25*3, y, null);
            g.drawImage(ph3, x+25*4, y, null);
        }
        
        for(int k=0;k<5;k++){
            g.drawImage(outline, x-2+25*k, y-2, null);
        }
        placer = TerraCraft.player.getBlockType();
        g.drawImage(selection, (x-2+25*(TerraCraft.keyHandler.getBPX())), y-2, null);
    }

}
