package com.connormahaffey.TerraCraft;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

/**
 *
 * @author Connor Mahaffey
 */
public class KeyHandler implements KeyListener{

    public static final int MODE_NONE = 0, MODE_GAME = 1, MODE_OVERLAY = 2;
    public boolean left, right, space;
    private boolean wasLeft, wasRight;
    private Game game;
    private int mode;
    
    private int bpx=0, bpy=0; //backpack x and backpack y

    public KeyHandler(Game game){
        this.game = game;
        mode = MODE_NONE;
        
    }

    public void keyTyped(KeyEvent e) {
        
        
    }

    public void keyPressed(KeyEvent e) {
        int key = e.getKeyCode();

        if(key == KeyEvent.VK_E && mode != MODE_NONE){
            if(game.getScreen() != Game.INV_SCREEN)
                game.setScreen(Game.INV_SCREEN);
            else
                game.setScreen(Game.GAME_SCREEN);

            if(mode == MODE_OVERLAY){
                setMode(MODE_GAME);
            }
            else{
                setMode(MODE_OVERLAY);
            }
        }

        if(mode == MODE_GAME){
            if(key == KeyEvent.VK_A || key == KeyEvent.VK_LEFT){
                left = true;
                if(right){
                    wasRight = true;
                    right = false;
                }
            }
            if(key == KeyEvent.VK_D || key == KeyEvent.VK_RIGHT){
                right = true;
                if(left){
                    wasLeft = true;
                    left = false;
                }
            }
            if(key == KeyEvent.VK_SPACE){
                space = true;
            }

            //temporary
            if(key == KeyEvent.VK_1){
                bpx = 0;
                TerraCraft.player.setBlock(TerraCraft.keyHandler.bpx+(5*TerraCraft.keyHandler.bpy+1));
            }
            else if(key == KeyEvent.VK_2){
                bpx = 1;
                TerraCraft.player.setBlock(TerraCraft.keyHandler.bpx+(5*TerraCraft.keyHandler.bpy+1));
            }
            else if(key == KeyEvent.VK_3){
                bpx = 2;
                TerraCraft.player.setBlock(TerraCraft.keyHandler.bpx+(5*TerraCraft.keyHandler.bpy+1));
            }
            else if(key == KeyEvent.VK_4){
                bpx = 3;
                TerraCraft.player.setBlock(TerraCraft.keyHandler.bpx+(5*TerraCraft.keyHandler.bpy+1));
            }
            else if(key == KeyEvent.VK_5){
                bpx = 4;
                TerraCraft.player.setBlock(TerraCraft.keyHandler.bpx+(5*TerraCraft.keyHandler.bpy+1));
            }
            
        }
        else if(mode == MODE_OVERLAY){
            //overlay key logic
            if(key == KeyEvent.VK_A || key == KeyEvent.VK_LEFT){
                if(bpx>0)
                    bpx--;
            }
            if(key == KeyEvent.VK_D || key == KeyEvent.VK_RIGHT){
                if(bpx<4)
                    bpx++;
            }
            if(key == KeyEvent.VK_W || key == KeyEvent.VK_UP){
                if(bpy>0)
                    bpy--;
            }
            if(key == KeyEvent.VK_S || key == KeyEvent.VK_DOWN){
                if(bpy<1)
                    bpy++;
            }
        }
        
    }

    public void keyReleased(KeyEvent e) {
        int key = e.getKeyCode();
        if(mode == MODE_GAME){
            if(key == KeyEvent.VK_A || key == KeyEvent.VK_LEFT){
                left = false;
                wasLeft = false;
                if(wasRight){
                    right = true;
                    wasRight = false;
                }
            }
            if(key == KeyEvent.VK_D || key == KeyEvent.VK_RIGHT){
                right = false;
                wasRight = false;
                if(wasLeft){
                    left = true;
                    wasLeft = false;
                }
            }
            if(key == KeyEvent.VK_SPACE){
                space = false;
            }
        }
        else if(mode == MODE_OVERLAY){

        }
    }

    public void setMode(int mode){
        this.mode = mode;
        right = false;
        wasRight = false;
        left = false;
        wasLeft = false;
        space = false;
    }

    public int getMode(){
        return mode;
    }

    public int getBPX(){
        return bpx;
    }

    public int getBPY(){
        return bpy;
    }

    public void setBPX(int x){
        bpx = x;
    }

    public void setBPY(int y){
        bpy = y;
    }
}
