package com.connormahaffey.TerraCraft;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.ArrayList;

/**
 *
 * @author Connor
 */
public class Player {
    
    private double x, y;
    private boolean creative=true;
    private int[] inventory;
    private int blockInHand, animationFrame;
    private ArrayList<Image> animation;

    public Player(){
        x = 0;
        y = -1300;//-1240
        inventory = new int[25];
        toggleCreative();
        blockInHand = 1;
        animation = new ArrayList<Image>();
        FileHandler fileHandler = new FileHandler();
        BufferedImage frames = fileHandler.getInternalImage("playeranimation.png");
        for(int i = 0; i < 6; i++){
            animation.add(fileHandler.getBlockImage(frames, i * 40, 0));//player is the size of a block
        }
        animationFrame = 0;
    }

    public void toggleCreative(){
        creative = !creative;
        for(int i = 0; i < inventory.length; i++){
            if(creative)
                inventory[i] = -1;//replace with 0 later, no infinite everything
            else
                inventory[i] = 0;
        }
    }

    public boolean isCreative(){
        return creative;
    }

    public String getInvValue(int k){
        if(inventory[k]<0)
            return "∞";
        else if(k<inventory.length-1)
            return ""+inventory[k];
        else return "ERROR";
    }

    public double getX(){
        return x;
    }

    public double getY(){
        return y;
    }

    public void setX(double x){
        this.x = x;
    }   

    public void setY(double y){
        this.y = y;
    }

    public void addBlock(int type){
        if(inventory[type] != -1){
            inventory[type]++;
        }
    }

    public boolean hasBlock(){
        if(inventory[blockInHand] != 0){
            return true;
        }
        else{
            return false;
        }
    }

    public void setBlock(int blockInHand){
        this.blockInHand = blockInHand;
    }

    public void setCreative(boolean creative){
        this.creative = creative;
    }

    public int getBlockType(){
        return blockInHand;
    }

    public int getBlock(){
        inventory[blockInHand]--;
        return blockInHand;
    }

    public void setInventory(double[] inventory){
        for(int i = 0; i < inventory.length; i++){
            this.inventory[i] = (int)inventory[i];
        }
    }

    public void setAnimationFrame(int animationFrame){
        this.animationFrame = animationFrame;
    }

    public Image getImage(){
        if(TerraCraft.keyHandler.left){
            return animation.get(animationFrame);
        }
        else if(TerraCraft.keyHandler.right){
            return animation.get(animationFrame + 3);
        }
        else{
            if(TerraCraft.mouseMotionHandler.getx() < TerraCraft.HALF_X){
                return animation.get(animationFrame);
            }
            else{
                return animation.get(animationFrame + 3);
            }
        }
    }

    public int[] getInventory(){
        return inventory;
    }
}
