package com.connormahaffey.TerraCraft;

/**
 *
 * @author Connor
 */
public class PlayerLogic extends Logic implements Runnable{

    //known issue, can still glitch into the middle of a block by mid-jump

    private final double X_SPEED = .15, ACCELERATION = .02, ANIMATION_SPEED = 150;
    private static double Y_SPEED = .30;//.60 for some fun, .30 is reg
    
    private World world;

    public PlayerLogic(World world){
        this.world = world;
    }

    public void run() {
        long time = System.currentTimeMillis(), oldTime = time, change = 0, animationTime = 0;

        double x, y, ySpeed = Y_SPEED, temp;
        Chunk chunk = null, chunk2 = null;
        Block block, block2;
        Location location, location2;
        boolean jumping = false, moved = false;
        int playerAnimation = 0, playerAnimationChange = 1;

        while(running){
            time = System.currentTimeMillis();
            change = time - oldTime;
            oldTime = time;
            if(pause){
                doPause();
                time = System.currentTimeMillis();
                oldTime = time;
                change = Logic.WAIT_PERIOD;
            }


            if(!jumping){
                if(animationTime >= ANIMATION_SPEED){
                    animationTime = 0;
                    playerAnimation += playerAnimationChange;
                    if(playerAnimation == 2 || playerAnimation == 0){
                        playerAnimationChange = -playerAnimationChange;
                    }
                    TerraCraft.player.setAnimationFrame(playerAnimation);
                }
            }
            

            x = TerraCraft.player.getX();
            y = TerraCraft.player.getY();
            //change it to jumping if the user presses space
            //make sure the user is standing on something to jump
            //will fall in water - no swimming
            if(TerraCraft.keyHandler.space){
                if(!jumping){
                    location = new Location(x, y + World.BLOCK_SIZE);
                    location2 = new Location(x + World.BLOCK_SIZE, y + World.BLOCK_SIZE);
                    chunk = world.getChunkAt(location);
                    block = chunk.getBlock(location);
                    chunk = world.getChunkAt(location2);
                    block2 = chunk.getBlock(location2);
                    if(block.isSolid() || block2.isSolid()){
                        jumping = true;
                        TerraCraft.player.setAnimationFrame(2);
                        playerAnimationChange = -1;
                        ySpeed = -Y_SPEED;
                    }
                }
            }
            //fall if possible and end jumping if they hit something solid
            if(ySpeed<=.60){
                ySpeed += ACCELERATION;
            }
            y += change * ySpeed;
            if(y > -(World.CHUNK_HEIGHT_PIXELS - 20)){//if it isn't out of the world
                location = new Location(x, y);
                location2 = new Location(x + World.BLOCK_SIZE, y);
                block = world.getChunkAt(location).getBlock(location);
                block2 = world.getChunkAt(location2).getBlock(location2);
                if(block.isSolid() || block2.isSolid()){
                    ySpeed = Y_SPEED;
                    temp = TerraCraft.player.getY() % 20;
                    if(temp < -0.5){
                        y = TerraCraft.player.getY() - temp;
                        if(temp < -10){
                            y -= 20;
                        }
                    }
                    else{
                        y = TerraCraft.player.getY();
                    }

                    if(jumping){
                        TerraCraft.player.setAnimationFrame(0);
                        playerAnimation = 0;
                        playerAnimationChange = 1;
                    }
                    jumping = false;
                }
            }
            else{
                y = TerraCraft.player.getY();
                ySpeed = 0;
            }
            
            //make it so they can't jump up through blocks
            location = new Location(x, y - World.BLOCK_SIZE);
            block = world.getChunkAt(location).getBlock(location);
            location2 = new Location(x + World.BLOCK_SIZE, y - World.BLOCK_SIZE);
            block2 = world.getChunkAt(location2).getBlock(location2);
            if(!block.isSolid() && !block2.isSolid()){
                TerraCraft.player.setY(y);
            }
            else{
                if(ySpeed < 0){
                    ySpeed = 0;
                }
            }
            //do left and right movement
            if(TerraCraft.keyHandler.left){
                moved = true;
                x -= change * X_SPEED;
                location = new Location(x, y - World.BLOCK_SIZE + 2);
                location2 = new Location(x, y);
            }
            if(TerraCraft.keyHandler.right){
                moved = true;
                x += change * X_SPEED;
                location = new Location(x + World.BLOCK_SIZE, y - World.BLOCK_SIZE + 2);
                location2 = new Location(x + World.BLOCK_SIZE, y);
            }
            if(moved || jumping){
                animationTime += change;
            }
            else{
                playerAnimation = 0;
                playerAnimationChange = 1;
                TerraCraft.player.setAnimationFrame(playerAnimation);
            }
            moved = false;
            //check if left or right movement is valid
            if(location != null){
                chunk = world.getChunkAt(location);
                chunk2 = world.getChunkAt(location2);
            }
            if(chunk != null && chunk2 != null){
                block = chunk.getBlock(location);
                block2 = chunk2.getBlock(location2);
                if(!block.isSolid() && !block2.isSolid()){
                    TerraCraft.player.setX(x);
                }
            }
            //sleep
            logicWait((int)(Logic.WAIT_PERIOD - (time - System.currentTimeMillis())));
        }

        finished = true;
    }

    public static void setSpeed(double speed){
        Y_SPEED = speed;
    }

    public static void toggleSpeed(){
        if(Y_SPEED == .60){
            Y_SPEED = .30;
        } else {
            Y_SPEED = .60;
        }
    }

    public static double getYSpeed(){
        return Y_SPEED;
    }

    public static boolean isSuperJump(){
        if(Y_SPEED == .60){
            return true;
        }
        else{
            return false;
        }
    }
}
