/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.connormahaffey.TerraCraft;

import java.awt.Dimension;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 *
 * @author Connor
 */
public class TerraCraft {

    public static final int SIZE_X = 720, SIZE_Y = 480, OFF_X = 350, OFF_Y = 220, HALF_X = 360, HALF_Y = 240;
    public static Player player;
    public static KeyHandler keyHandler;
    public static MouseMotionHandler mouseMotionHandler;
    public static MouseHandler mouseHandler;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args){
        FileHandler fileHandler = new FileHandler();
        JFrame frame = new JFrame("TerraCraft - Connor Mahaffey and Reed Swiernik");
        frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        frame.setIconImage(fileHandler.getInternalImage("icon.png"));
        frame.setSize(SIZE_X, SIZE_Y);
        frame.setResizable(false);
        frame.setLocationRelativeTo(null);
        Game game = new Game();
        player = new Player();
        game.setBounds(0, 0, SIZE_X, SIZE_Y);
        game.setIgnoreRepaint(true);

        JPanel container = (JPanel)frame.getContentPane();
        container.setPreferredSize(new Dimension(SIZE_X, SIZE_Y));
        container.add(game);

        frame.addWindowListener(new WindowHandler(game));
        frame.addWindowFocusListener(new WindowFocusHandler(game));

        frame.setVisible(true);

        game.requestFocus();
        game.createBufferStrategy(2);
        game.init();

        
        keyHandler = new KeyHandler(game);
        mouseHandler = new MouseHandler();
        mouseMotionHandler = new MouseMotionHandler();

        game.addKeyListener(keyHandler);
        game.addMouseListener(mouseHandler);
        game.addMouseMotionListener(mouseMotionHandler);
        
        game.loop();
    }

}
